#include "stdafx.h"
#include "CryptoWrappersHelpers.h"
#include "CryptoWrappersProvider.h"
#include "CryptoWrappersCNGProvider.h"
#include "CryptoWrappersCNGSecret.h"
#include "CryptoWrappersStore.h"
#include "CryptoWrappersChainEngine.h"
#include "CryptoWrappersOCSPServerResponse.h"
#include "CryptoWrappersMessage.h"
#include "CryptoWrappersCNGStorageProvider.h"
#include "CryptoWrappersCNGSecret2.h"
#include <array>
#include <atlbase.h>


CryptoWrappers::CProvider GenerateDefaultProvider() noexcept
{
  return {};
}


#pragma warning(suppress: 26485)
int _tmain(int /*argc*/, _TCHAR* /*argv*/[]) //NOLINT(modernize-avoid-c-arrays)
{
  CryptoWrappers::CCNGProvider prov1;
#pragma warning(suppress: 26486)
  CryptoWrappers::CCNGProvider prov2;
#pragma warning(suppress: 26486)
  BCRYPT_ALG_HANDLE hHandle{prov1.Handle()}; //NOLINT(clang-analyzer-deadcode.DeadStores)
  NTSTATUS status{prov1.Open(BCRYPT_AES_ALGORITHM, nullptr, 0)}; //NOLINT(clang-analyzer-deadcode.DeadStores, clang-diagnostic-unused-but-set-variable)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));
  hHandle = prov1.Handle(); //NOLINT(clang-analyzer-deadcode.DeadStores)
  hHandle = prov1.Detach();
  prov1.Attach(hHandle);
  CryptoWrappers::CCNGProvider prov4;
  status = prov4.Open(BCRYPT_RSA_ALGORITHM, nullptr, 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));

  CryptoWrappers::CCNGKey key1;
#pragma warning(suppress: 26486)
  status = prov4.GenerateKeyPair(1024, key1); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));
  status = key1.FinalizeKeyPair(); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));

  DWORD dwDataLen{0};
  BOOL bSuccess{FALSE};
  std::vector<BYTE> binary;
  PCERT_PUBLIC_KEY_INFO pPublicKeyInfo{nullptr};
#if (NTDDI_VERSION >= NTDDI_WIN7)
  bSuccess = key1.ExportPublicKeyInfo(X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, nullptr, 0, nullptr, &dwDataLen); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  binary.resize(dwDataLen);
#pragma warning(suppress: 26490)
  bSuccess = key1.ExportPublicKeyInfo(X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, nullptr, 0, reinterpret_cast<PCERT_PUBLIC_KEY_INFO>(binary.data()), &dwDataLen); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
#pragma warning(suppress: 26490)
  pPublicKeyInfo = reinterpret_cast<PCERT_PUBLIC_KEY_INFO>(binary.data());
#endif //#if (NTDDI_VERSION >= NTDDI_WIN7)

  std::vector<UCHAR> key{32, std::allocator<UCHAR>{}};
#pragma warning(suppress: 26472)
  for (UCHAR i=0; i<static_cast<UCHAR>(key.size()); i++)
#pragma warning(suppress: 26446)
    key[i] = i;
  CryptoWrappers::CCNGKey key2;
#pragma warning(suppress: 26472 26486)
  status = prov1.CreateSymmetricKey(nullptr, 0, key.data(), static_cast<ULONG>(key.size()), key2); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));

  ULONG cbResult{0};
  status = key2.Export(nullptr, BCRYPT_KEY_DATA_BLOB, nullptr, 0, &cbResult); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));
  std::vector<UCHAR> buffer1{cbResult, std::allocator<UCHAR>{}};
  status = key2.Export(nullptr, BCRYPT_KEY_DATA_BLOB, buffer1.data(), cbResult, &cbResult); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));

  CryptoWrappers::CCNGHash hash1;
  CryptoWrappers::CCNGProvider provHash;
  status = provHash.Open(BCRYPT_SHA1_ALGORITHM, nullptr, 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));
#pragma warning(suppress: 26486)
  status = provHash.CreateHash(nullptr, 0, nullptr, 0, 0, hash1); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));

  CryptoWrappers::CCNGHash hash2{hash1};
#pragma warning(suppress: 26486)
  hash1 = hash2;
  BCRYPT_HASH_HANDLE hHash{hash1.Handle()};
  UNREFERENCED_PARAMETER(hHash);
  CryptoWrappers::CCNGHash hash3;
  hash3.Attach(hash1.Detach());
  CryptoWrappers::CCNGHash hash4;
#pragma warning(suppress: 26486)
  status = provHash.CreateHash(nullptr, 0, nullptr, 0, 0, hash4); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));
  hash4 = CryptoWrappers::CCNGHash{};
  CryptoWrappers::CCNGHash hash5(hash3.Detach());
  const char* pszDataToHash{"The quick brown fox"};
#pragma warning(suppress: 26465 26490 26472 26492)
  status = hash5.HashData(const_cast<PUCHAR>(reinterpret_cast<const UCHAR*>(pszDataToHash)), static_cast<ULONG>(strlen(pszDataToHash))); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));
  std::array<BYTE, 20> Hash{};
#pragma warning(suppress: 26472)
  status = hash5.FinishHash(Hash.data(), static_cast<ULONG>(Hash.size())); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));

#if (NTDDI_VERSION >= NTDDI_WINTHRESHOLD)
  CryptoWrappers::CCNGProvider provHash2;
  status = provHash2.Open(BCRYPT_SHA1_ALGORITHM, nullptr, 0);
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));
  UCHAR hash[20];
  status = provHash2.Hash(nullptr, 0, reinterpret_cast<PUCHAR>(pszDataToHash), static_cast<ULONG>(strlen(pszDataToHash)), hash, sizeof(hash));
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));
#endif

  CryptoWrappers::CCNGKey key3;
#pragma warning(suppress: 26486 26472)
  status = prov1.ImportKey(nullptr, BCRYPT_KEY_DATA_BLOB, nullptr, 0, buffer1.data(), static_cast<ULONG>(buffer1.size()), key3); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));

  status = key1.Export(nullptr, BCRYPT_RSAPRIVATE_BLOB, nullptr, 0, &cbResult); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));
  buffer1.resize(cbResult);
  status = key1.Export(nullptr, BCRYPT_RSAPRIVATE_BLOB, buffer1.data(), cbResult, &cbResult); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));
#pragma warning(suppress: 26490)
  const BCRYPT_RSAKEY_BLOB* pBlob{reinterpret_cast<BCRYPT_RSAKEY_BLOB*>(buffer1.data())};
  UNREFERENCED_PARAMETER(pBlob);

  CryptoWrappers::CCNGKey key4;
#pragma warning(suppress: 26486)
  status = prov4.ImportKeyPair(BCRYPT_RSAPRIVATE_BLOB, buffer1.data(), cbResult, 0, key4); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));

  CryptoWrappers::CCNGProvider prov5;
  status = prov5.Open(BCRYPT_RSA_SIGN_ALGORITHM, nullptr, 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));
  CryptoWrappers::CCNGKey keySign;
#pragma warning(suppress: 26486)
  status = prov5.GenerateKeyPair(1024, keySign); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));
  status = keySign.FinalizeKeyPair(); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));
  BCRYPT_PKCS1_PADDING_INFO pkcspi;
  pkcspi.pszAlgId = nullptr;
#pragma warning(suppress: 26472)
  status = keySign.SignHash(&pkcspi, Hash.data(), static_cast<ULONG>(Hash.size()), nullptr, 0, &cbResult, BCRYPT_PAD_PKCS1); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));
  buffer1.resize(cbResult);
#pragma warning(suppress: 26472)
  status = keySign.SignHash(&pkcspi, Hash.data(), static_cast<ULONG>(Hash.size()), buffer1.data(), cbResult, &cbResult, BCRYPT_PAD_PKCS1); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));
#pragma warning(suppress: 26472)
  status = keySign.VerifySignature(&pkcspi, Hash.data(), static_cast<ULONG>(Hash.size()), buffer1.data(), cbResult, BCRYPT_PAD_PKCS1); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));

  std::array<wchar_t, 1024> szAlgorithmName{};
  cbResult = 0;
#pragma warning(suppress: 26472 26490)
  status = prov4.GetProperty(BCRYPT_ALGORITHM_NAME, reinterpret_cast<PUCHAR>(szAlgorithmName.data()), static_cast<ULONG>(szAlgorithmName.size()), &cbResult); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));

#pragma warning(suppress: 26490 26465 26472 26492)
  status = prov1.SetProperty(BCRYPT_CHAINING_MODE, const_cast<PUCHAR>(reinterpret_cast<const UCHAR*>(BCRYPT_CHAIN_MODE_CBC)), static_cast<ULONG>(wcslen(BCRYPT_CHAIN_MODE_CBC)*sizeof(wchar_t))); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));

  CryptoWrappers::CCNGProvider prov6;
  status = prov6.Open(BCRYPT_RNG_ALGORITHM, nullptr, 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));
  std::vector<UCHAR> buffer2{100, std::allocator<UCHAR>{}};
#pragma warning(suppress: 26472)
  status = prov6.GenRandom(buffer2.data(), static_cast<ULONG>(buffer2.size()), 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));

  CryptoWrappers::CCNGKey key5{key3};
  key5 = key3;
  CryptoWrappers::CCNGKey key6{key5.Detach()};
  BCRYPT_KEY_HANDLE hKey{key6.Handle()};
  UNREFERENCED_PARAMETER(hKey);
  szAlgorithmName = {};
  cbResult = 0;
#pragma warning(suppress: 26490)
  status = key6.GetProperty(BCRYPT_ALGORITHM_NAME, reinterpret_cast<PUCHAR>(szAlgorithmName.data()), sizeof(szAlgorithmName), &cbResult); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));
  DWORD dwKeyLength{0};
#pragma warning(suppress: 26490)
  status = key6.GetProperty(BCRYPT_KEY_LENGTH, reinterpret_cast<PUCHAR>(&dwKeyLength), sizeof(dwKeyLength), &cbResult); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));

  CryptoWrappers::CCNGKey key7;
#pragma warning(suppress: 26472 26486)
  status = prov1.CreateSymmetricKey(nullptr, 0, key.data(), static_cast<ULONG>(key.size()), key7); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));
  dwKeyLength = 0;
#pragma warning(suppress: 26490)
  status = key6.GetProperty(BCRYPT_KEY_LENGTH, reinterpret_cast<PUCHAR>(&dwKeyLength), sizeof(dwKeyLength), &cbResult); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));


  CryptoWrappers::CCNGKey key8;
  key8.Attach(key7.Detach());
  CryptoWrappers::CCNGKey key9;
  key9 = CryptoWrappers::CCNGKey();

  const char* pszPlainText{"The quick brown fox"};
  cbResult = 0;
#pragma warning(suppress: 26490 26465 26472 26492)
  status = key8.Encrypt(const_cast<PUCHAR>(reinterpret_cast<const UCHAR*>(pszPlainText)), static_cast<ULONG>(strlen(pszPlainText)), nullptr, nullptr, 0, nullptr, 0, &cbResult, BCRYPT_BLOCK_PADDING); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));
  buffer1.resize(cbResult);
#pragma warning(suppress: 26490 26465 26472 26492)
  status = key8.Encrypt(const_cast<PUCHAR>(reinterpret_cast<const UCHAR*>(pszPlainText)), static_cast<ULONG>(strlen(pszPlainText)), nullptr, nullptr, 0, buffer1.data(), cbResult, &cbResult, BCRYPT_BLOCK_PADDING); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));

  cbResult = 0;
#pragma warning(suppress: 26472)
  status = key8.Decrypt(buffer1.data(), static_cast<ULONG>(buffer1.size()), nullptr, nullptr, 0, nullptr, 0, &cbResult, BCRYPT_BLOCK_PADDING); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));
  std::vector<UCHAR> buffer3{cbResult, std::allocator<UCHAR>{}};
#pragma warning(suppress: 26472)
  status = key8.Decrypt(buffer1.data(), static_cast<ULONG>(buffer1.size()), nullptr, nullptr, 0, buffer3.data(), static_cast<ULONG>(buffer3.size()), &cbResult, BCRYPT_BLOCK_PADDING); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));

#if (NTDDI_VERSION >= NTDDI_WIN8)
  CryptoWrappers::CCNGProvider provKDF;
  status = provKDF.Open(BCRYPT_PBKDF2_ALGORITHM, nullptr, 0);
  ATLASSUME(BCRYPT_SUCCESS(status));
  CryptoWrappers::CCNGKey key10;
  status = provKDF.CreateSymmetricKey(nullptr, 0, key, sizeof(key), key10);
  ATLASSUME(BCRYPT_SUCCESS(status));
  UCHAR keyData[1024]{};
  cbResult = 0;
  status = key10.KeyDerivation(nullptr, keyData, sizeof(keyData), &cbResult, 0);
#endif //#if (NTDDI_VERSION >= NTDDI_WIN8)

  CryptoWrappers::CCNGKey key11{CryptoWrappers::CCNGKey(nullptr)};


  CryptoWrappers::CCNGSecret secret1;
  BCRYPT_SECRET_HANDLE hSecret{secret1.Handle()};
  UNREFERENCED_PARAMETER(hSecret);

  CryptoWrappers::CCNGProvider prov7;
  status = prov7.Open(BCRYPT_ECDH_P384_ALGORITHM, nullptr, 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));
  CryptoWrappers::CCNGKey key12;
#pragma warning(suppress: 26486)
  status = prov7.GenerateKeyPair(384, key12); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));
  status = key12.FinalizeKeyPair(); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));
  cbResult = 0;
  status = key12.Export(nullptr, BCRYPT_ECCPUBLIC_BLOB, nullptr, 0, &cbResult); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));
  buffer1.resize(cbResult);
  status = key12.Export(nullptr, BCRYPT_ECCPUBLIC_BLOB, buffer1.data(), cbResult, &cbResult); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));
  CryptoWrappers::CCNGKey key13;
#pragma warning(suppress: 26486)
  status = prov7.ImportKeyPair(BCRYPT_ECCPUBLIC_BLOB, buffer1.data(), cbResult, 0, key13); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));
  status = secret1.Create(key12.Handle(), key13.Handle()); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));
  CryptoWrappers::CCNGSecret secret3;
  CryptoWrappers::CCNGKey key14;
  status = secret1.DeriveKey(BCRYPT_KDF_HASH, nullptr, nullptr, 0, &cbResult, 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));
  buffer3.resize(cbResult);
  status = secret1.DeriveKey(BCRYPT_KDF_HASH, nullptr, buffer3.data(), cbResult, &cbResult, 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));
  CryptoWrappers::CCNGSecret secret4{secret1.Detach()};

  CryptoWrappers::String sString;
  std::array<BYTE, 20> buffer4{};
#pragma warning(suppress: 26472)
  status = prov6.GenRandom(buffer4.data(), static_cast<ULONG>(buffer4.size()), 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(BCRYPT_SUCCESS(status));
#pragma warning(suppress: 26472)
  bSuccess = CryptoWrappers::BinaryToString(buffer4.data(), static_cast<DWORD>(buffer4.size()), CRYPT_STRING_HEXASCII, sString); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  bSuccess = CryptoWrappers::StringToBinary(sString.c_str(), 0, CRYPT_STRING_HEXASCII, binary, nullptr, nullptr); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  const std::array<BYTE, 9> byData{'0','2',' ','0','1',' ', '0', '1', 0};
  std::wstring sFormat;
#pragma warning(suppress: 26472)
  bSuccess = CryptoWrappers::FormatObject(X509_ASN_ENCODING, 0, nullptr, byData.data(), static_cast<DWORD>(byData.size()), sFormat); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);

 #ifdef _AFX
  CString sString2;
  bSuccess = CryptoWrappers::BinaryToString(buffer4, sizeof(buffer4), CRYPT_STRING_HEXASCII, sString2);
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  CStringW sFormat2;
  bSuccess = CryptoWrappers::FormatObject(X509_ASN_ENCODING, 0, nullptr, byData, sizeof(byData), sFormat2);
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
 #endif //#ifdef _AFX

  CryptoWrappers::CProvider prov8;
  CryptoWrappers::CProvider prov9{prov8};
  prov8 = prov9;
  bSuccess = prov9.Acquire(nullptr, nullptr, PROV_RSA_FULL, CRYPT_VERIFYCONTEXT); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  prov8 = prov9;
  CryptoWrappers::CProvider prov10{prov8};
  prov8.Release();
  prov8.Attach(prov10.Detach());
  DWORD dwKeySpec = 0;
  dwDataLen = sizeof(dwDataLen);
#pragma warning(suppress: 26490)
  bSuccess = prov8.GetParam(PP_KEYSPEC, reinterpret_cast<BYTE*>(&dwKeySpec), &dwDataLen, 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
#pragma warning(suppress: 26462)
  const HWND hDesktopWnd{GetDesktopWindow()};
#pragma warning(suppress: 26490)
  bSuccess = prov8.SetParam(PP_CLIENT_HWND, reinterpret_cast<const BYTE*>(&hDesktopWnd), 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
  buffer4 = {};
#pragma warning(suppress: 26472)
  bSuccess = prov8.GenRandom(static_cast<DWORD>(buffer4.size()), buffer4.data()); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  prov9 = prov8;
  CryptoWrappers::CProvider prov11{GenerateDefaultProvider()};

  CryptoWrappers::CDefaultContext ctx1;
  bSuccess = prov9.InstallDefault(CRYPT_DEFAULT_CONTEXT_CERT_SIGN_OID, nullptr, 0, ctx1); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  CryptoWrappers::CDefaultContext ctx2;
  ctx2.Attach(ctx1.Detach());

  CryptoWrappers::CKey key15;
  bSuccess = prov9.GenKey(CALG_DES, CRYPT_EXPORTABLE, key15); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);

  CryptoWrappers::CKey key16;
  bSuccess = prov9.GetUserKey(AT_KEYEXCHANGE, key16);
#pragma warning(suppress: 26472)
  if (!bSuccess && (GetLastError() == static_cast<DWORD>(NTE_NO_KEY)))
  {
    bSuccess = prov9.GenKey(AT_KEYEXCHANGE, CRYPT_EXPORTABLE, key16); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
    ATLASSUME(bSuccess);
  }
  key16.Destroy();
  bSuccess = prov9.GetUserKey(AT_SIGNATURE, key16);
#pragma warning(suppress: 26472)
  if (!bSuccess && GetLastError() == static_cast<DWORD>(NTE_NO_KEY))
  {
    bSuccess = prov9.GenKey(AT_SIGNATURE, CRYPT_EXPORTABLE, key16); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
    ATLASSUME(bSuccess);
  }

  CryptoWrappers::CHash hash6;
  bSuccess = prov9.CreateHash(CALG_MD5, NULL, 0, hash6); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
#pragma warning(suppress: 26472)
  bSuccess = hash6.HashData(buffer4.data(), static_cast<DWORD>(buffer4.size()), 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  CryptoWrappers::CKey key17;
  bSuccess = prov9.DeriveKey(CALG_RC2, hash6.Handle(), CRYPT_EXPORTABLE, key17); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);

  bSuccess = key17.Export(NULL, PLAINTEXTKEYBLOB, 0, nullptr, &dwDataLen); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  binary.resize(dwDataLen);
  bSuccess = key17.Export(NULL, PLAINTEXTKEYBLOB, 0, binary.data(), &dwDataLen); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  CryptoWrappers::CKey key18;
#pragma warning(suppress: 26472)
  bSuccess = prov9.ImportKey(binary.data(), static_cast<DWORD>(binary.size()), NULL, 0, key18); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);


  LPCTSTR pszPemPublicKey{
    _T("-----BEGIN PUBLIC KEY-----\r\n")
    _T("MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQC6GUVcbn92bahlwOskKi8XkG9q\r\n")
    _T("Vq863+C4cOWC6HzJojc011pJFFIBu8/pG1EI8FZJdBmTrFaJTriYw1/SpbOH0QqE\r\n")
    _T("eHanT8qWn+S5m9xgDJoWTBJKcnu3OHOvJJU3c8jOHQQnRWLfghJH4vnwStdiwUUY\r\n")
    _T("SMWpwuHObsNelGBgEQIDAQAB\r\n")
    _T("-----END PUBLIC KEY-----\r\n")};
  bSuccess = CryptoWrappers::StringToBinary(pszPemPublicKey, 0, CRYPT_STRING_BASE64_ANY, binary); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);

  pPublicKeyInfo = nullptr;
  DWORD dwPublicKeyInfoLen{0};
#pragma warning(suppress: 26472)
  bSuccess = CryptDecodeObjectEx(X509_ASN_ENCODING|PKCS_7_ASN_ENCODING, X509_PUBLIC_KEY_INFO, binary.data(), static_cast<DWORD>(binary.size()), CRYPT_DECODE_ALLOC_FLAG, nullptr, &pPublicKeyInfo, &dwPublicKeyInfoLen); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  CryptoWrappers::CKey key23;
  bSuccess = prov9.ImportPublicKeyInfo(X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, pPublicKeyInfo, key23); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  ALG_ID algID{0};
  dwDataLen = sizeof(algID);
#pragma warning(suppress: 26490)
  bSuccess = key23.GetParam(KP_ALGID, reinterpret_cast<BYTE*>(&algID), &dwDataLen); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  CryptoWrappers::CKey key24;
  bSuccess = prov9.ImportPublicKeyInfoEx(X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, pPublicKeyInfo, algID, key24); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  dwDataLen = 0;
  bSuccess = prov9.ExportPublicKeyInfo(AT_KEYEXCHANGE, X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, nullptr, &dwDataLen); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  binary.resize(dwDataLen);
#pragma warning(suppress: 26490)
  bSuccess = prov9.ExportPublicKeyInfo(AT_KEYEXCHANGE, X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, reinterpret_cast<PCERT_PUBLIC_KEY_INFO>(binary.data()), &dwDataLen); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  dwDataLen = 0;
#pragma warning(suppress: 26465 26492)
  bSuccess = prov9.ExportPublicKeyInfoEx(AT_KEYEXCHANGE, X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, const_cast<LPSTR>(szOID_RSA_RSA), 0, nullptr, &dwDataLen); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  binary.resize(dwDataLen);
#pragma warning(suppress: 26465 26490 26492)
  bSuccess = prov9.ExportPublicKeyInfoEx(AT_KEYEXCHANGE, X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, const_cast<LPSTR>(szOID_RSA_RSA), 0, reinterpret_cast<PCERT_PUBLIC_KEY_INFO>(binary.data()), &dwDataLen); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  LocalFree(pPublicKeyInfo);

  const char* pszSubjectName{"This certificate user"};
  CERT_RDN_ATTR rgNameAttr{};
#pragma warning(suppress: 26465 26492)
  rgNameAttr.pszObjId = const_cast<LPSTR>("2.5.4.3");
  rgNameAttr.dwValueType = CERT_RDN_PRINTABLE_STRING;
#pragma warning(suppress: 26472)
  rgNameAttr.Value.cbData = static_cast<DWORD>(strlen(pszSubjectName));
#pragma warning(suppress: 26465 26490 26492)
  rgNameAttr.Value.pbData = const_cast<BYTE*>(reinterpret_cast<const BYTE*>(pszSubjectName));
  CERT_RDN rgRDN{};
  rgRDN.cRDNAttr = 1;
  rgRDN.rgRDNAttr = &rgNameAttr;
  CERT_NAME_INFO Name{};
  Name.cRDN = 1;
  Name.rgRDN = &rgRDN;
  DWORD cbNameEncoded{0};
  bSuccess = CryptEncodeObject(X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, X509_NAME, &Name, nullptr, &cbNameEncoded); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  std::vector<BYTE> nameBinary{cbNameEncoded, std::allocator<BYTE>{}};
  bSuccess = CryptEncodeObject(X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, X509_NAME, &Name, nameBinary.data(), &cbNameEncoded); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  //CERT_NAME_BLOB SubjNameBlob{};
  //SubjNameBlob.cbData = cbNameEncoded;
  //SubjNameBlob.pbData = &(binary[0]);
  //CERT_REQUEST_INFO CertReqInfo{};
  //CertReqInfo.Subject = SubjNameBlob;
  //CertReqInfo.cAttribute = 0;
  //CertReqInfo.rgAttribute = nullptr;
  //CertReqInfo.dwVersion = CERT_REQUEST_V1;
  dwDataLen = 0;
  bSuccess = prov9.ExportPublicKeyInfo(AT_SIGNATURE, X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, nullptr, &dwDataLen); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  binary.resize(dwDataLen);
#pragma warning(suppress: 26490)
  bSuccess = prov9.ExportPublicKeyInfo(AT_SIGNATURE, X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, reinterpret_cast<PCERT_PUBLIC_KEY_INFO>(binary.data()), &dwDataLen); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
#pragma warning(suppress: 26490)
  pPublicKeyInfo = reinterpret_cast<CERT_PUBLIC_KEY_INFO*>(binary.data());
  CRYPT_ALGORITHM_IDENTIFIER SigAlg{};
#pragma warning(suppress: 26465 26492)
  SigAlg.pszObjId = const_cast<LPSTR>(szOID_OIWSEC_sha1RSASign);
  CERT_REQUEST_INFO cri{};
  cri.dwVersion = CERT_V1;
  cri.Subject.cbData = cbNameEncoded;
  cri.Subject.pbData = nameBinary.data();
  cri.SubjectPublicKeyInfo = *pPublicKeyInfo;
  cri.cAttribute = 0;
  cri.rgAttribute = nullptr;
  DWORD cbEncodedCertReqSize{0};
  bSuccess = prov9.SignAndEncodeCertificate(AT_SIGNATURE, X509_ASN_ENCODING, X509_CERT_REQUEST_TO_BE_SIGNED, &cri, &SigAlg, nullptr, &cbEncodedCertReqSize); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  bSuccess = prov9.SignCertificate(AT_SIGNATURE, X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, nullptr, 0, &SigAlg, nullptr, &dwDataLen); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);

  CryptoWrappers::CHash hash7{hash6};
  CryptoWrappers::CHash hash8;
  hash8.Attach(hash7.Detach());
  hash6 = hash8;
  CryptoWrappers::CHash hash9{CryptoWrappers::CHash(hash6.Detach())};
  CryptoWrappers::CHash hash10;
  hash10 = CryptoWrappers::CHash(hash9.Detach());
  ALG_ID AlgID{0};
  dwDataLen = sizeof(AlgID);
#pragma warning(suppress: 26490)
  bSuccess = hash10.GetParam(HP_ALGID, reinterpret_cast<BYTE*>(&AlgID), &dwDataLen); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);


  CryptoWrappers::CProvider prov12;
  bSuccess = prov12.Acquire(nullptr, nullptr, PROV_RSA_FULL, 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  CryptoWrappers::CKey key19;
  bSuccess = prov12.GenKey(CALG_3DES, 0, key19); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  CryptoWrappers::CHash hash11;
  bSuccess = prov12.CreateHash(CALG_MD5, NULL, 0, hash11); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  bSuccess = hash11.HashSessionKey(key19.Handle(), 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);

  CryptoWrappers::CHash hash12;
  bSuccess = prov12.CreateHash(CALG_MD5, NULL, 0, hash12); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);

  std::array<BYTE, 16> byHash{0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15};
  bSuccess = hash12.SetParam(HP_HASHVAL, byHash.data()); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  CryptoWrappers::CKey keySignature;
  bSuccess = prov12.GetUserKey(AT_SIGNATURE, keySignature);
#pragma warning(suppress: 26472)
  if (!bSuccess && (GetLastError() == static_cast<DWORD>(NTE_NO_KEY)))
  {
    bSuccess = prov12.GenKey(AT_SIGNATURE, CRYPT_EXPORTABLE, keySignature); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
    ATLASSUME(bSuccess);
  }
  dwDataLen = 0;
  bSuccess = hash12.SignHash(AT_SIGNATURE, 0, nullptr, &dwDataLen); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  binary.resize(dwDataLen);
  bSuccess = hash12.SignHash(AT_SIGNATURE, 0, binary.data(), &dwDataLen); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  bSuccess = hash12.VerifySignature(binary.data(), dwDataLen, keySignature.Handle(), 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);

  CryptoWrappers::CKey key20{key19};
  CryptoWrappers::CKey key21{key20};
  key20 = key21;
  CryptoWrappers::CKey key22;
  key22.Attach(key20.Detach());

  dwDataLen = sizeof(AlgID);
#pragma warning(suppress: 26490)
  bSuccess = key22.GetParam(KP_ALGID, reinterpret_cast<BYTE*>(&AlgID), &dwDataLen); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  dwDataLen = 0;

  CryptoWrappers::CProvider provAES;
  bSuccess = provAES.Acquire(nullptr, nullptr, PROV_RSA_AES, 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  CryptoWrappers::CKey keyWithSalt;
  bSuccess = provAES.GenKey(CALG_AES_256, CRYPT_EXPORTABLE, keyWithSalt); //NOLINT(clang-analyzer-deadcode.DeadStores)
  std::vector<BYTE> IV{32, std::allocator<BYTE>{}};
#pragma warning(suppress: 26472)
  for (BYTE i=0; i<static_cast<BYTE>(IV.size()); i++)
#pragma warning(suppress: 26446)
    IV[i] = i;
  bSuccess = keyWithSalt.SetParam(KP_IV, IV.data(), 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);

#pragma warning(suppress: 26472)
  const auto dwPlainTextLen{static_cast<DWORD>(strlen(pszPlainText))};
  dwDataLen = dwPlainTextLen;
  bSuccess = key19.Encrypt(NULL, TRUE, 0, nullptr, &dwDataLen, dwPlainTextLen); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  binary.resize(dwDataLen);
  for (DWORD i=0; i<dwPlainTextLen; i++)
#pragma warning(suppress: 26481 26446)
    binary[i] = pszPlainText[i];
  const DWORD dwCipherTextLen{dwDataLen};
  dwDataLen = dwPlainTextLen;
  bSuccess = key19.Encrypt(NULL, TRUE, 0, binary.data(), &dwDataLen, dwCipherTextLen); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);

  dwDataLen = dwCipherTextLen;
  bSuccess = key19.Decrypt(NULL, TRUE, 0, binary.data(), &dwDataLen); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);

  CryptoWrappers::CStore store1;
  bSuccess = store1.Open(CERT_STORE_PROV_SYSTEM, 0, CERT_SYSTEM_STORE_CURRENT_USER | CERT_STORE_OPEN_EXISTING_FLAG | CERT_STORE_READONLY_FLAG, L"My"); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  store1.Close();
  bSuccess = store1.OpenSystemStore(_T("CA")); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);

  CryptoWrappers::CCertificate cert1;
  do
  {
    cert1 = store1.EnumCertificates(cert1);
    if (cert1.Handle() != nullptr)
    {
      CryptoWrappers::String sFriendlyName;
      cert1.GetNameString(CERT_NAME_FRIENDLY_DISPLAY_TYPE, CERT_NAME_STR_ENABLE_PUNYCODE_FLAG, nullptr, sFriendlyName);
      ATLTRACE(_T("Found Cert with friendly name: %s\n"), sFriendlyName.c_str());

      dwDataLen = 0;
      bSuccess = cert1.SerializeStoreElement(nullptr, &dwDataLen); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
      ATLASSUME(bSuccess);
      binary.resize(dwDataLen);
      bSuccess = cert1.SerializeStoreElement(binary.data(), &dwDataLen); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
      ATLASSUME(bSuccess);

      OutputDebugString(_T("Serialized form of this certificate is\n"));
      CryptoWrappers::String sReturn;
#pragma warning(suppress: 26472)
      bSuccess = CryptoWrappers::BinaryToString(binary.data(), static_cast<DWORD>(binary.size()), 0, sReturn); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
      ATLASSUME(bSuccess);
      OutputDebugString(sReturn.c_str());
      OutputDebugString(_T("\n"));
    }
  }
  while (cert1.Handle());

  CryptoWrappers::CCTL ctl_1;
  do
  {
      ctl_1 = store1.EnumCTLs(ctl_1);
  }
  while (ctl_1.Handle());

  CryptoWrappers::CCRL crl1;
  do
  {
      crl1 = store1.EnumCRLs(crl1);
  }
  while (crl1.Handle());


  CryptoWrappers::CStore store2{store1};
  store1 = store2;
  store2.Close();
  store2.Attach(store1.Detach());
  HCERTSTORE hStore{store2.Handle()};
  UNREFERENCED_PARAMETER(hStore);
  store1 = CryptoWrappers::CStore();
  CryptoWrappers::CStore store3{store2.Detach()};
  bSuccess = store3.Control(CERT_STORE_CTRL_COMMIT_CLEAR_FLAG, CERT_STORE_CTRL_COMMIT, nullptr); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);

  bSuccess = store3.AddStoreToCollection(nullptr, 0, 2); //NOLINT(clang-analyzer-deadcode.DeadStores)
  store3.RemoveStoreFromCollection(store1);
  CERT_BLOB certBlob{};
  certBlob.cbData = 0;
  certBlob.pbData = nullptr;
  bSuccess = store3.Save(PKCS_7_ASN_ENCODING | X509_ASN_ENCODING, CERT_STORE_SAVE_AS_PKCS7, CERT_STORE_SAVE_TO_MEMORY, &certBlob); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  binary.resize(certBlob.cbData);
  certBlob.pbData = binary.data();
  bSuccess = store3.Save(PKCS_7_ASN_ENCODING | X509_ASN_ENCODING, CERT_STORE_SAVE_AS_PKCS7, CERT_STORE_SAVE_TO_MEMORY, &certBlob); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);

  CRYPT_DATA_BLOB propertyNameBlob{};
#pragma warning(suppress: 26465 26490 26492)
  propertyNameBlob.pbData = const_cast<BYTE*>(reinterpret_cast<const BYTE*>(L"The Local MY Store"));
#pragma warning(suppress: 26472 26481 26490)
  propertyNameBlob.cbData = static_cast<DWORD>(wcslen(reinterpret_cast<LPCWSTR>(propertyNameBlob.pbData)+1) * sizeof(wchar_t));
  bSuccess = store3.SetProperty(CERT_STORE_LOCALIZED_NAME_PROP_ID, &propertyNameBlob); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  dwDataLen = 0;
  bSuccess = store3.GetProperty(CERT_STORE_LOCALIZED_NAME_PROP_ID, nullptr, &dwDataLen); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  CryptoWrappers::CCertificate cert2{store3.SelectCertificate(nullptr, nullptr, nullptr, 0)};

  CRYPT_DATA_BLOB dataBlob{};
  bSuccess = store3.PFXExport(&dataBlob, L"password", nullptr, EXPORT_PRIVATE_KEYS); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  binary.resize(dataBlob.cbData);
  dataBlob.pbData = binary.data();
  bSuccess = store3.PFXExport(&dataBlob, L"password", nullptr, EXPORT_PRIVATE_KEYS); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  CryptoWrappers::CStore store4;
  bSuccess = store4.PFXImport(&dataBlob, L"password", CRYPT_USER_KEYSET | PKCS12_NO_PERSIST_KEY); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);

  std::array<BYTE, 791> byCer{0x5C, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x04,
                              0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x53, 0x85, 0xD6, 0xB8, 0x07,
                              0x6A, 0x29, 0x1E, 0x90, 0xC8, 0xD1, 0x80, 0x97, 0x2E, 0x65, 0x44, 0x14, 0x00, 0x00, 0x00, 0x01,
                              0x00, 0x00, 0x00, 0x14, 0x00, 0x00, 0x00, 0x2A, 0x00, 0x59, 0x2E, 0x8C, 0x25, 0x4C, 0xF7, 0x1E,
                              0xD9, 0xD1, 0xDE, 0xCD, 0x81, 0x63, 0x5D, 0x7E, 0x0A, 0xC9, 0xE8, 0x03, 0x00, 0x00, 0x00, 0x01,
                              0x00, 0x00, 0x00, 0x14, 0x00, 0x00, 0x00, 0x7B, 0xD4, 0x93, 0x48, 0x1F, 0xDD, 0x32, 0x44, 0x8B,
                              0x7A, 0xBC, 0xE9, 0x42, 0x7E, 0x72, 0x0F, 0x2D, 0x4E, 0x2A, 0x7E, 0x19, 0x00, 0x00, 0x00, 0x01,
                              0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x17, 0x19, 0x4F, 0x59, 0xC4, 0x89, 0x6A, 0x0A, 0x3B,
                              0x09, 0x60, 0xA6, 0x86, 0xFF, 0x9E, 0xE1, 0x0F, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x14,
                              0x00, 0x00, 0x00, 0x0C, 0x47, 0x9B, 0x70, 0x68, 0x78, 0x69, 0xDE, 0x7D, 0x8E, 0x24, 0xA5, 0x59,
                              0x5D, 0xCB, 0x63, 0xCF, 0xF1, 0x46, 0x0D, 0x18, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x10,
                              0x00, 0x00, 0x00, 0xED, 0xBC, 0xCD, 0xD5, 0x10, 0x6A, 0x07, 0x1C, 0x5D, 0x8B, 0x46, 0x90, 0x91,
                              0x8E, 0x48, 0xAA, 0x20, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x47, 0x02, 0x00, 0x00, 0x30,
                              0x82, 0x02, 0x43, 0x30, 0x82, 0x01, 0xF1, 0xA0, 0x03, 0x02, 0x01, 0x02, 0x02, 0x10, 0x18, 0x2A,
                              0xF6, 0xAB, 0x47, 0xBD, 0x33, 0xA6, 0x42, 0xE2, 0x5B, 0xFE, 0x72, 0xEB, 0x92, 0x03, 0x30, 0x09,
                              0x06, 0x05, 0x2B, 0x0E, 0x03, 0x02, 0x1D, 0x05, 0x00, 0x30, 0x16, 0x31, 0x14, 0x30, 0x12, 0x06,
                              0x03, 0x55, 0x04, 0x03, 0x13, 0x0B, 0x52, 0x6F, 0x6F, 0x74, 0x20, 0x41, 0x67, 0x65, 0x6E, 0x63,
                              0x79, 0x30, 0x1E, 0x17, 0x0D, 0x31, 0x34, 0x30, 0x37, 0x31, 0x38, 0x32, 0x30, 0x32, 0x31, 0x35,
                              0x34, 0x5A, 0x17, 0x0D, 0x33, 0x39, 0x31, 0x32, 0x33, 0x31, 0x32, 0x33, 0x35, 0x39, 0x35, 0x39,
                              0x5A, 0x30, 0x22, 0x31, 0x20, 0x30, 0x1E, 0x06, 0x03, 0x55, 0x04, 0x03, 0x13, 0x17, 0x4A, 0x6F,
                              0x65, 0x27, 0x73, 0x2D, 0x53, 0x6F, 0x66, 0x74, 0x77, 0x61, 0x72, 0x65, 0x2D, 0x45, 0x6D, 0x70,
                              0x6F, 0x72, 0x69, 0x75, 0x6D, 0x30, 0x82, 0x01, 0x22, 0x30, 0x0D, 0x06, 0x09, 0x2A, 0x86, 0x48,
                              0x86, 0xF7, 0x0D, 0x01, 0x01, 0x01, 0x05, 0x00, 0x03, 0x82, 0x01, 0x0F, 0x00, 0x30, 0x82, 0x01,
                              0x0A, 0x02, 0x82, 0x01, 0x01, 0x00, 0xAE, 0xCB, 0xD7, 0x0E, 0x77, 0xA2, 0x40, 0x31, 0x04, 0xC8,
                              0x92, 0xDE, 0x95, 0x1E, 0x37, 0x55, 0xCE, 0x17, 0x73, 0x20, 0x04, 0x80, 0xAF, 0xB3, 0x39, 0x02,
                              0x12, 0x29, 0x0E, 0x3E, 0x85, 0xA4, 0x61, 0x19, 0x67, 0x99, 0x15, 0xBC, 0x2A, 0xD5, 0x52, 0x19,
                              0xC1, 0xAB, 0x1E, 0x9B, 0x51, 0x03, 0x20, 0x7D, 0x8A, 0xAC, 0xAA, 0xA4, 0x78, 0x22, 0xDF, 0x6B,
                              0xA8, 0xD7, 0xBE, 0xA8, 0xF6, 0x62, 0xDF, 0xAE, 0x39, 0x4F, 0x1B, 0xDB, 0x4D, 0x10, 0x00, 0xB7,
                              0x92, 0x91, 0x5B, 0x72, 0xB6, 0xD2, 0x96, 0x28, 0x2C, 0x26, 0x62, 0xFB, 0x1E, 0xEB, 0x66, 0x26,
                              0xE8, 0xDB, 0x79, 0x4B, 0xBD, 0x5E, 0x19, 0xE0, 0x4B, 0xFA, 0x83, 0x5F, 0x2B, 0xF7, 0xB7, 0x08,
                              0x94, 0x74, 0x4A, 0x43, 0x10, 0xF1, 0x25, 0xF2, 0xAF, 0xCA, 0x2E, 0x8D, 0x85, 0x1C, 0x6C, 0xDF,
                              0x35, 0xEA, 0x31, 0xAA, 0xA1, 0x8F, 0x1B, 0xEF, 0xEF, 0xF4, 0xB8, 0xE0, 0x4F, 0x80, 0x18, 0xA3,
                              0x9B, 0x09, 0xE6, 0x1E, 0x30, 0x88, 0x2C, 0x9F, 0xFA, 0x05, 0xE2, 0xD3, 0x88, 0x3F, 0xD8, 0xB5,
                              0xC7, 0x89, 0xA2, 0x68, 0xB8, 0xA6, 0x90, 0x1E, 0x68, 0x2D, 0x80, 0xA8, 0x0C, 0x81, 0xB6, 0x25,
                              0xBC, 0x43, 0x4C, 0x9A, 0x40, 0xF3, 0xBE, 0xCC, 0x6D, 0x10, 0xBD, 0xEB, 0x13, 0x01, 0x66, 0x2F,
                              0xE6, 0x41, 0xA1, 0x0E, 0x9A, 0x22, 0xBA, 0xFD, 0xD2, 0x06, 0xC4, 0x7F, 0x37, 0xD2, 0x2B, 0x9F,
                              0xA5, 0xFC, 0xD8, 0x3A, 0x62, 0x47, 0x16, 0x89, 0xBA, 0xF0, 0xA5, 0x44, 0x99, 0x2C, 0x91, 0xF2,
                              0x2E, 0xC1, 0xEC, 0x54, 0xD4, 0xE2, 0x5C, 0x11, 0x60, 0xFB, 0x15, 0xDE, 0x6B, 0x52, 0x14, 0x44,
                              0x57, 0x54, 0xAC, 0xC0, 0xA9, 0x01, 0x04, 0xD1, 0x4B, 0x64, 0x69, 0x26, 0x34, 0x4A, 0x8F, 0x2C,
                              0x0C, 0x35, 0xB6, 0xB9, 0x21, 0x85, 0x02, 0x03, 0x01, 0x00, 0x01, 0xA3, 0x4B, 0x30, 0x49, 0x30,
                              0x47, 0x06, 0x03, 0x55, 0x1D, 0x01, 0x04, 0x40, 0x30, 0x3E, 0x80, 0x10, 0x12, 0xE4, 0x09, 0x2D,
                              0x06, 0x1D, 0x1D, 0x4F, 0x00, 0x8D, 0x61, 0x21, 0xDC, 0x16, 0x64, 0x63, 0xA1, 0x18, 0x30, 0x16,
                              0x31, 0x14, 0x30, 0x12, 0x06, 0x03, 0x55, 0x04, 0x03, 0x13, 0x0B, 0x52, 0x6F, 0x6F, 0x74, 0x20,
                              0x41, 0x67, 0x65, 0x6E, 0x63, 0x79, 0x82, 0x10, 0x06, 0x37, 0x6C, 0x00, 0xAA, 0x00, 0x64, 0x8A,
                              0x11, 0xCF, 0xB8, 0xD4, 0xAA, 0x5C, 0x35, 0xF4, 0x30, 0x09, 0x06, 0x05, 0x2B, 0x0E, 0x03, 0x02,
                              0x1D, 0x05, 0x00, 0x03, 0x41, 0x00, 0x34, 0x4A, 0xE1, 0x09, 0x28, 0x9B, 0x93, 0x1E, 0x2B, 0xDD,
                              0x17, 0x47, 0xAD, 0x95, 0x15, 0x5F, 0xBC, 0xEE, 0xBC, 0x74, 0x71, 0x22, 0xD7, 0x2D, 0xCD, 0xC8,
                              0x7F, 0x13, 0xF7, 0x0B, 0x2D, 0xBD, 0xC3, 0xD4, 0x50, 0x4A, 0xE3, 0xB1, 0x5D, 0xCD, 0xE4, 0x03,
                              0x76, 0x77, 0xC0, 0x0D, 0x97, 0xEF, 0x81, 0xD0, 0x1C, 0xFE, 0x80, 0x4A, 0x3C, 0x0C, 0xFB, 0xC5,
                              0xAE, 0xE1, 0x22, 0x0A, 0x13, 0xB0};

  CryptoWrappers::CCertificate newCert;
#pragma warning(suppress: 26472 26490)
  bSuccess = store4.AddSerializedElement(byCer.data(), static_cast<DWORD>(byCer.size()), CERT_STORE_ADD_NEW | CERT_STORE_ADD_REPLACE_EXISTING, CERT_STORE_ALL_CONTEXT_FLAG, nullptr, reinterpret_cast<const void**>(&(newCert.m_pCert))); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  if (cert2.Handle() != nullptr)
    bSuccess = store4.AddCertifcate(cert2, CERT_STORE_ADD_NEW, nullptr); //NOLINT(clang-analyzer-deadcode.DeadStores)
  CryptoWrappers::CCRL crl2;
  crl1 = store3.EnumCRLs(crl2);
  bSuccess = store4.AddCRL(crl1, CERT_STORE_ADD_NEW, nullptr); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);

  if (cert2.Handle() != nullptr)
  {
    CryptoWrappers::CCertificate cert3(cert2);
    cert3 = store3.FindCertificate(X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, 0, CERT_FIND_ANY, nullptr, cert3);
  }
  ctl_1 = store3.FindCTL(X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, 0, CTL_FIND_ANY, nullptr, ctl_1);
  crl1 = store3.FindCRL(X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, 0, CRL_FIND_ANY, nullptr, crl1);

  CryptoWrappers::CChain chain1;
  chain1 = store3.FindChain(X509_ASN_ENCODING, 0, 0, nullptr, chain1);
  bSuccess = store4.AddEncodedCertificate(X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, newCert.m_pCert->pbCertEncoded, newCert.m_pCert->cbCertEncoded, CERT_STORE_ADD_NEW | CERT_STORE_ADD_REPLACE_EXISTING, nullptr); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
#pragma warning(suppress: 26472)
  bSuccess = store4.AddEncodedCTL(X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, byCer.data(), static_cast<DWORD>(byCer.size()), CERT_STORE_ADD_NEW, nullptr); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26472)
  bSuccess = store4.AddEncodedCRL(X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, byCer.data(), static_cast<DWORD>(byCer.size()), CERT_STORE_ADD_NEW, nullptr); //NOLINT(clang-analyzer-deadcode.DeadStores)

  if (cert2.Handle() != nullptr)
  {
    CERT_INFO ci{};
    ci.Issuer.cbData = cert2.Handle()->pCertInfo->Issuer.cbData;
    ci.Issuer.pbData = cert2.Handle()->pCertInfo->Issuer.pbData;
    ci.SerialNumber.cbData = cert2.Handle()->pCertInfo->SerialNumber.cbData;
    ci.SerialNumber.pbData = cert2.Handle()->pCertInfo->SerialNumber.pbData;
    CryptoWrappers::CCertificate cert4 = store3.GetSubjectCertificate(X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, &ci);
  }

#if (NTDDI_VERSION >= NTDDI_WIN7)
  DWORD dwSelection{0};
  PCCERT_CHAIN_CONTEXT* pCertChainContext{nullptr};
  bSuccess = store3.SelectCertificateChains(nullptr, 0, nullptr, 0, nullptr, &dwSelection, &pCertChainContext); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  if (pCertChainContext != nullptr)
  {
    for (DWORD i=0; i<dwSelection; i++)
#pragma warning(suppress: 26481)
      CertFreeCertificateChain(pCertChainContext[i]);
    CertFreeCertificateChainList(pCertChainContext);
  }
#endif //#if (NTDDI_VERSION >= NTDDI_WIN7)

  CryptoWrappers::CCertificate cert5;
  DWORD dwFlags{0};
  crl1 = store3.GetCRL(cert5, crl1, &dwFlags);


  CryptoWrappers::CCertificate cert6;
  if (cert2.Handle() != nullptr)
    cert6 = cert2;
  CryptoWrappers::CCertificate cert7;
  bSuccess = cert7.Create(X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, newCert.m_pCert->pbCertEncoded, newCert.m_pCert->cbCertEncoded); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  bSuccess = cert7.DlgView(nullptr, nullptr); //NOLINT(clang-analyzer-deadcode.DeadStores)

  DWORD dwPropID{0};
  do
  {
      dwPropID = cert7.EnumProperties(dwPropID);
      if (dwPropID != 0)
      {
        DWORD cbData{0};
        bSuccess = cert7.GetProperty(dwPropID, nullptr, &cbData); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
        ATLASSUME(bSuccess);
        binary.resize(cbData);
        bSuccess = cert7.GetProperty(dwPropID, binary.data(), &cbData); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
        ATLASSUME(bSuccess);

        //bSuccess = cert7.SetProperty(dwPropID, 0, &(binary[0]));

        ATLTRACE(_T("Found Property %u\n"), dwPropID);
      }
  }
  while (dwPropID != 0);

  DWORD cbElement{0};
  bSuccess = cert7.SerializeStoreElement(nullptr, &cbElement); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  binary.resize(cbElement);
  bSuccess = cert7.SerializeStoreElement(binary.data(), &cbElement); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);

  BYTE* pbyData{nullptr};
  DWORD cbData{0};
#pragma warning(suppress: 26481)
  bSuccess = cert7.RetrieveLogoOrBiometricInfo(CERT_RETRIEVE_BIOMETRIC_PICTURE_TYPE, CRYPT_DONT_CACHE_RESULT, 5000, &pbyData, &cbData, nullptr);
  if (bSuccess)
  {
      if (pbyData != nullptr)
          CryptMemFree(pbyData);
  }

  bSuccess = cert7.AddEnhancedKeyUsageIdentifier(szOID_WINDOWS_STORE_SIGNER); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  bSuccess = cert7.RemoveEnhancedKeyUsageIdentifier(szOID_WINDOWS_STORE_SIGNER); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);

  DWORD cbUsage{0};
  bSuccess = cert7.GetEnhancedKeyUsage(0, nullptr, &cbUsage); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  binary.resize(cbUsage);
#pragma warning(suppress: 26490)
  bSuccess = cert7.GetEnhancedKeyUsage(0, reinterpret_cast<CERT_ENHKEY_USAGE*>(binary.data()), &cbUsage); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);

#pragma warning(suppress: 26490)
  auto pEKU{reinterpret_cast<CERT_ENHKEY_USAGE*>(binary.data())};
  bSuccess = cert7.SetEnhancedKeyUsageIdentifier(pEKU); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);

  DWORD cbCtlEntry{0};
  bSuccess = cert7.CreateCTLEntry(0, nullptr, 0, nullptr, &cbCtlEntry); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  binary.resize(cbCtlEntry);
#pragma warning(suppress: 26490)
  bSuccess = cert7.CreateCTLEntry(0, nullptr, 0, reinterpret_cast<PCTL_ENTRY>(binary.data()), &cbCtlEntry); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
#pragma warning(suppress: 26490)
  auto pCtlEntry{reinterpret_cast<PCTL_ENTRY>(binary.data())};
  bSuccess = cert7.SetPropertiesFromCTLEntry(pCtlEntry, 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  bSuccess = cert7.IsValidCRL(crl1.Handle()); //NOLINT(clang-analyzer-deadcode.DeadStores)

  //bSuccess = cert7.DeleteFromStore();

  CryptoWrappers::CChainEngine engine1;
  CERT_CHAIN_ENGINE_CONFIG ccec{};
  ccec.cbSize = sizeof(ccec);
  bSuccess = engine1.Create(&ccec); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  CryptoWrappers::CChainEngine engine2;
  engine2.Attach(engine1.Detach());
  CERT_CHAIN_PARA chainPara{};
  chainPara.cbSize = sizeof(chainPara);
  CryptoWrappers::CChain chain2;
  bSuccess = engine2.GetChain(cert7.Handle(), nullptr, nullptr, &chainPara, 0, chain2); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  HCERTCHAINENGINE hEngine{engine2.Handle()};
  UNREFERENCED_PARAMETER(hEngine);
  CryptoWrappers::CChainEngine engine3{engine1.Detach()};

  CryptoWrappers::CCRL crl3;
  crl3 = store3.EnumCRLs(crl3);
  CryptoWrappers::CCRL crl4(crl3);
  CryptoWrappers::CCRL crl5;
  crl5 = crl4;
  cbElement = 0;
  bSuccess = crl5.SerializeStoreElement(nullptr, &cbElement); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  binary.resize(cbElement);
  bSuccess = crl5.SerializeStoreElement(binary.data(), &cbElement); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  CryptoWrappers::CCRL crl6;
  bSuccess = crl6.Create(X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, crl5.m_pCRL->pbCrlEncoded, crl5.m_pCRL->cbCrlEncoded); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  bSuccess = crl5.DlgView(nullptr, nullptr); //NOLINT(clang-analyzer-deadcode.DeadStores)

  dwPropID = 0;
  do
  {
      dwPropID = crl5.EnumProperties(dwPropID);
      if (dwPropID != 0)
      {
        cbData = 0;
        bSuccess = crl5.GetProperty(dwPropID, nullptr, &cbData); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
        ATLASSUME(bSuccess);
        binary.resize(cbData);
        bSuccess = crl5.GetProperty(dwPropID, binary.data(), &cbData); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
        ATLASSUME(bSuccess);
        //bSuccess = crl5.SetProperty(dwPropID, 0, &(binary[0]));
        ATLTRACE(_T("Found Property %u\n"), dwPropID);
      }
  }
  while (dwPropID != 0);

  CryptoWrappers::CCRL crl7;
  //bSuccess = crl7.DeleteFromStore();

  PCRL_ENTRY pCRLEntry{nullptr};
  bSuccess = crl5.FindCertificate(cert7, &pCRLEntry); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);

  CryptoWrappers::CCTL ctl2;
  CryptoWrappers::CStore store5;
  bSuccess = store5.Open(CERT_STORE_PROV_SYSTEM_A, 0, CERT_STORE_OPEN_EXISTING_FLAG | CERT_STORE_READONLY_FLAG | CERT_SYSTEM_STORE_CURRENT_USER, "CA"); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  ctl2 = store5.FindCTL(X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, 0, CTL_FIND_ANY, nullptr, ctl2);

  if (ctl2.Handle() != nullptr)
  {
    cbElement = 0;
    bSuccess = ctl2.SerializeStoreElement(nullptr, &cbElement); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
    ATLASSUME(bSuccess);
    binary.resize(cbElement);
    bSuccess = ctl2.SerializeStoreElement(binary.data(), &cbElement); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
    ATLASSUME(bSuccess);

    CryptoWrappers::CCTL ctl3;
    bSuccess = ctl3.Create(X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, ctl2.m_pCTL->pbCtlEncoded, ctl2.m_pCTL->cbCtlEncoded); //NOLINT(clang-analyzer-deadcode.DeadStores)

    ctl2.DlgView(nullptr, nullptr);
    dwPropID = 0;
    do
    {
      dwPropID = ctl2.EnumProperties(dwPropID);
      if (dwPropID != 0)
      {
        cbData = 0;
        bSuccess = ctl2.GetProperty(dwPropID, nullptr, &cbData); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
        ATLASSUME(bSuccess);
        binary.resize(cbData);
        bSuccess = ctl2.GetProperty(dwPropID, binary.data(), &cbData); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
        ATLASSUME(bSuccess);
        //bSuccess = ctl2.SetProperty(dwPropID, 0, &(binary[0]));
        ATLTRACE(_T("Found Property %u\n"), dwPropID);
      }
    }
    while (dwPropID != 0);

    void* pNextSubject{nullptr};
    CRYPT_DER_BLOB cdb1{};
    CRYPT_DER_BLOB cdb2{};
    bSuccess = ctl2.EnumSubjectInSorted(&pNextSubject, &cdb1, &cdb2); //NOLINT(clang-analyzer-deadcode.DeadStores)

    CTL_ANY_SUBJECT_INFO casi{};
#pragma warning(suppress: 26465 26492)
    casi.SubjectAlgorithm.pszObjId = const_cast<LPSTR>(szOID_RSA_SHA1RSA);
    std::array<BYTE, 20> bySubjectAlgorithm{0x43, 0x36, 0x94, 0xb2, 0x0a, 0x25, 0x86, 0x58, 0x62, 0x5a, 0x0c, 0x93, 0x7b, 0x2b, 0x2f, 0x38, 0xc1, 0xa0, 0xcc, 0x14};
    casi.SubjectAlgorithm.Parameters.pbData = bySubjectAlgorithm.data();
#pragma warning(suppress: 26472)
    casi.SubjectAlgorithm.Parameters.cbData = static_cast<DWORD>(bySubjectAlgorithm.size());
    std::array<BYTE, 20> bySubjectIdentifier{0x3b, 0x1e, 0xfd, 0x3a, 0x66, 0xea, 0x28, 0xb1, 0x66, 0x97, 0x39, 0x47, 0x03, 0xa7, 0x2c, 0xa3, 0x40, 0xa0, 0x5b, 0xd5};
    casi.SubjectIdentifier.pbData = bySubjectIdentifier.data();
#pragma warning(suppress: 26472)
    casi.SubjectIdentifier.cbData = static_cast<DWORD>(bySubjectIdentifier.size());
    const CTL_ENTRY* pEntry{ctl2.FindSubject(X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, CTL_ANY_SUBJECT_TYPE, &casi)};
    UNREFERENCED_PARAMETER(pEntry);

    CRYPT_DER_BLOB cdb3{};
    bSuccess = ctl2.FindSubjectInSorted(&casi.SubjectIdentifier, &cdb3); //NOLINT(clang-analyzer-deadcode.DeadStores)

    bSuccess = ctl2.DeleteFromStore(); //NOLINT(clang-analyzer-deadcode.DeadStores)
  }


  CryptoWrappers::CProvider prov13;
  bSuccess = prov13.Acquire(nullptr, nullptr, PROV_RSA_FULL, CRYPT_VERIFYCONTEXT); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  CryptoWrappers::CDefaultContext ctx4;
  bSuccess = prov13.InstallDefault(CRYPT_DEFAULT_CONTEXT_CERT_SIGN_OID, szOID_OIWSEC_md5RSA, 0, ctx4); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  CryptoWrappers::CDefaultContext ctx6(ctx4.Detach());

  CryptoWrappers::CChain chain3;
  PCCERT_CHAIN_CONTEXT hChain{chain3.Handle()};
  UNREFERENCED_PARAMETER(hChain);
  CryptoWrappers::CChain prevChain;
  CERT_CHAIN_FIND_BY_ISSUER_PARA ccfip{};
  ccfip.cbSize = sizeof(ccfip);

  CryptoWrappers::CStore store6;
  bSuccess = store6.Open(CERT_STORE_PROV_SYSTEM_A, PKCS_7_ASN_ENCODING | X509_ASN_ENCODING, CERT_STORE_OPEN_EXISTING_FLAG | CERT_STORE_READONLY_FLAG | CERT_SYSTEM_STORE_LOCAL_MACHINE, "CA"); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  chain3 = store6.FindChain(X509_ASN_ENCODING, 0, CERT_CHAIN_FIND_BY_ISSUER, &ccfip, prevChain);
  if (chain3.Handle())
  {
      CryptoWrappers::CChain chain4{chain3};
      chain3 = chain4;

    #if (NTDDI_VERSION >= NTDDI_VISTA)
      CryptoWrappers::COCSPServerResponse ocsp1;
      CryptoWrappers::COCSPServerResponse ocsp2{ocsp1};
      ocsp1 = ocsp2;
      bSuccess = ocsp1.Open(chain3.Handle()); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
      ATLASSUME(bSuccess);
      HCERT_SERVER_OCSP_RESPONSE hOCSP{ocsp1.Handle()};
      UNREFERENCED_PARAMETER(hOCSP);

      CryptoWrappers::COCSPResponseContext ocrc1{ocsp1.GetResponseContext()};
      CryptoWrappers::COCSPResponseContext ocrc2(ocrc1);
      ocrc1 = ocrc2;
      PCCERT_SERVER_OCSP_RESPONSE_CONTEXT hocrc1{ocrc1.Handle()};
      UNREFERENCED_PARAMETER(hocrc1);
    #endif //#if (NTDDI_VERSION >= NTDDI_VISTA)
  }

#if (NTDDI_VERSION >= NTDDI_VISTA)
  CryptoWrappers::COCSPServerResponse ocsp3;
  HCERT_SERVER_OCSP_RESPONSE hOCSP2{ocsp3.Detach()};
  ocsp3.Attach(hOCSP2);
  //CryptoWrappers::COCSPServerResponse ocsp4{ocsp3};
  //bSuccess = ocsp4.Open(nullptr);
  //ocsp4.Close();
  //CryptoWrappers::COCSPResponseContext ocrc2{ocsp4.GetResponseContext()};
  CryptoWrappers::COCSPResponseContext ocrc3;
  //ocrc3 = ocrc2;
  //ocrc2.Attach(ocrc3.Detach());
  //CryptoWrappers::COCSPResponseContext ocrc4{ocrc2};
#endif //#if (NTDDI_VERSION >= NTDDI_VISTA)

  CryptoWrappers::CMessage msg1;
  //CryptoWrappers::CMessage msg2{msg1};
  //msg1 = msg2;
  msg1 = CryptoWrappers::CMessage{};
  HCRYPTMSG hMsg{msg1.Handle()};
  UNREFERENCED_PARAMETER(hMsg);
  //CryptoWrappers::CMessage msg3(msg2.Detach());
  CRYPT_ALGORITHM_IDENTIFIER HashAlgorithm{};
#pragma warning(suppress: 26465 26492)
  HashAlgorithm.pszObjId = const_cast<LPSTR>(szOID_RSA_MD5);
  CMSG_SIGNER_ENCODE_INFO SignerEncodeInfo{};
  SignerEncodeInfo.cbSize = sizeof(CMSG_SIGNER_ENCODE_INFO);
  CryptoWrappers::CCertificate cert8;
  cert8 = store5.EnumCertificates(cert8);
  SignerEncodeInfo.pCertInfo = cert8.Handle()->pCertInfo;
  SignerEncodeInfo.hCryptProv = prov9.Handle();
  SignerEncodeInfo.dwKeySpec = AT_KEYEXCHANGE;
  SignerEncodeInfo.HashAlgorithm = HashAlgorithm;
  SignerEncodeInfo.pvHashAuxInfo = nullptr;
  CERT_BLOB SignerCertBlob{};
  SignerCertBlob.cbData = cert8.Handle()->cbCertEncoded;
  SignerCertBlob.pbData = cert8.Handle()->pbCertEncoded;
  CMSG_SIGNED_ENCODE_INFO SignedMsgEncodeInfo{};
  SignedMsgEncodeInfo.cbSize = sizeof(CMSG_SIGNED_ENCODE_INFO);
  SignedMsgEncodeInfo.cSigners = 1;
  SignedMsgEncodeInfo.rgSigners = &SignerEncodeInfo;
  SignedMsgEncodeInfo.cCertEncoded = 1;
  SignedMsgEncodeInfo.rgCertEncoded = &SignerCertBlob;
  SignedMsgEncodeInfo.rgCrlEncoded = nullptr;
  bSuccess = msg1.OpenToEncode(X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, 0, CMSG_SIGNED, &SignedMsgEncodeInfo, nullptr, nullptr); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
#pragma warning(suppress: 26490 26472)
  bSuccess = msg1.Update(reinterpret_cast<const BYTE*>(pszPlainText), static_cast<DWORD>(strlen(pszPlainText)), TRUE); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
#pragma warning(suppress: 26490)
  bSuccess = msg1.Control(0, CMSG_CTRL_DEL_CERT, reinterpret_cast<const void*>(42)); //NOLINT(clang-analyzer-deadcode.DeadStores)
  bSuccess = msg1.GetParam(CMSG_CONTENT_PARAM, 0, nullptr, &cbData); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  binary.resize(cbData);
  bSuccess = msg1.GetParam(CMSG_CONTENT_PARAM, 0, binary.data(), &cbData); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);

  CryptoWrappers::CMessage msg4;
  bSuccess = msg4.OpenToDecode(X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, 0, 0, nullptr); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
#pragma warning(suppress: 26472)
  bSuccess = msg4.Update(binary.data(), static_cast<DWORD>(binary.size()), TRUE); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  bSuccess = msg1.Countersign(0, 1, &SignerEncodeInfo); //NOLINT(clang-analyzer-deadcode.DeadStores)

  CryptoWrappers::CCNGStorageProvider storprov1;
  NCRYPT_PROV_HANDLE hHandle3{storprov1.Handle()}; //NOLINT(clang-analyzer-deadcode.DeadStores)
  hHandle3 = storprov1.Handle(); //NOLINT(clang-analyzer-deadcode.DeadStores)
  hHandle3 = storprov1.Detach();
  storprov1.Attach(hHandle3);
  CryptoWrappers::CCNGStorageProvider storprov2{storprov1.Detach()};
  SECURITY_STATUS secStatus{storprov2.Open(MS_KEY_STORAGE_PROVIDER)}; //NOLINT(clang-analyzer-deadcode.DeadStores, clang-diagnostic-unused-but-set-variable)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(secStatus));
  CryptoWrappers::CCNGStorageProvider storprov3{storprov1.Detach()};

  NCryptAlgorithmName* pAlgorithmNames{nullptr};
  DWORD dwAlgCount{0};
  secStatus = storprov2.EnumAlgorithms(0, &dwAlgCount, &pAlgorithmNames, 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(secStatus));
#pragma warning(suppress: 26481)
  secStatus = storprov2.IsAlgSupported(pAlgorithmNames[0].pszName, 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(secStatus));
  NCryptFreeBuffer(pAlgorithmNames);
  NCryptKeyName* pKeyNames{nullptr};
  PVOID pEnumState{nullptr};
  secStatus = storprov2.EnumKeys(&pKeyNames, &pEnumState, 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
  NCryptFreeBuffer(pKeyNames);
  HANDLE hChange{nullptr};
  secStatus = storprov2.NotifyChangeKey(&hChange, NCRYPT_REGISTER_NOTIFY_FLAG); //NOLINT(clang-analyzer-deadcode.DeadStores)
  CryptoWrappers::CCNGKey2 key25;
  secStatus = storprov2.CreatePersistedKey(BCRYPT_ECDH_P384_ALGORITHM, L"PJs Key", 0, NCRYPT_OVERWRITE_KEY_FLAG, key25); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(secStatus));
  DWORD dwExportPolicy{NCRYPT_ALLOW_EXPORT_FLAG | NCRYPT_ALLOW_PLAINTEXT_EXPORT_FLAG};
#pragma warning(suppress: 26490)
  secStatus = key25.SetProperty(NCRYPT_EXPORT_POLICY_PROPERTY, reinterpret_cast<PBYTE>(&dwExportPolicy), sizeof(dwExportPolicy), 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(secStatus));
  secStatus = key25.Finalize(0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(secStatus));
  dwDataLen = 0;
  secStatus = key25.Export(NULL, BCRYPT_PUBLIC_KEY_BLOB, nullptr, nullptr, 0, &dwDataLen, 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(secStatus));
  binary.resize(dwDataLen);
  secStatus = key25.Export(NULL, BCRYPT_PUBLIC_KEY_BLOB, nullptr, binary.data(), dwDataLen, &dwDataLen, 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(secStatus));
  CryptoWrappers::CCNGKey2 key27;
#pragma warning(suppress: 26472)
  secStatus = storprov2.ImportKey(NULL, BCRYPT_PUBLIC_KEY_BLOB, nullptr, binary.data(), static_cast<DWORD>(binary.size()), 0, key27); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(secStatus));
  CryptoWrappers::CCNGKey2 key26;
  secStatus = storprov2.CreatePersistedKey(BCRYPT_RSA_ALGORITHM, nullptr, 0, 0, key26); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(secStatus));
  secStatus = key26.Finalize(0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(secStatus));

  bSuccess = key26.ExportPublicKeyInfo(X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, nullptr, &dwDataLen); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  binary.resize(dwDataLen);
#pragma warning(suppress: 26490)
  bSuccess = key26.ExportPublicKeyInfo(X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, reinterpret_cast<PCERT_PUBLIC_KEY_INFO>(binary.data()), &dwDataLen); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  dwDataLen = 0;
#pragma warning(suppress: 26465 26492)
  bSuccess = key26.ExportPublicKeyInfoEx(X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, const_cast<LPSTR>(szOID_RSA_RSA), 0, nullptr, &dwDataLen); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  binary.resize(dwDataLen);
#pragma warning(suppress: 26465 26490 26492)
  bSuccess = key26.ExportPublicKeyInfoEx(X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, const_cast<LPSTR>(szOID_RSA_RSA), 0, reinterpret_cast<PCERT_PUBLIC_KEY_INFO>(binary.data()), &dwDataLen); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);
  CryptoWrappers::CCNGKey2 key28;
  secStatus = storprov2.OpenKey(L"PJs Key", 0, 0, key28); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(secStatus));
  dwExportPolicy = NCRYPT_ALLOW_EXPORT_FLAG | NCRYPT_ALLOW_PLAINTEXT_EXPORT_FLAG;
#pragma warning(suppress: 26490)
  secStatus = key26.SetProperty(NCRYPT_EXPORT_POLICY_PROPERTY, reinterpret_cast<PBYTE>(&dwExportPolicy), sizeof(dwExportPolicy), 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(secStatus));
  CryptoWrappers::CCNGKey2 key29;
  CryptoWrappers::CCNGKey2 key30{key29.Detach()};
  const NCRYPT_KEY_HANDLE hHandle4{key29.Handle()};
  UNREFERENCED_PARAMETER(hHandle4);
  dwDataLen = 0;
  secStatus = key28.GetProperty(NCRYPT_ALGORITHM_PROPERTY, nullptr, dwDataLen, &dwDataLen, 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(secStatus));
  binary.resize(dwDataLen);
  secStatus = key28.GetProperty(NCRYPT_ALGORITHM_PROPERTY, binary.data(), dwDataLen, &dwDataLen, 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(secStatus));

  CryptoWrappers::CCNGSecret2 secret5;
  secStatus = secret5.Create(key25.Handle(), key25.Handle(), 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(secStatus));
  CryptoWrappers::CCNGKey2 key31;
  dwDataLen = 0;
  secStatus = secret5.DeriveKey(BCRYPT_KDF_HASH, nullptr, nullptr, dwDataLen, &dwDataLen, 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(secStatus));
  binary.resize(cbResult);
  secStatus = secret5.DeriveKey(BCRYPT_KDF_HASH, nullptr, binary.data(), dwDataLen, &dwDataLen, 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(secStatus));

  CryptoWrappers::CCNGSecret2 secret6;
  CryptoWrappers::CCNGSecret2 secret7{secret6.Detach()};
  const NCRYPT_SECRET_HANDLE hHandle5{secret7.Handle()};
  UNREFERENCED_PARAMETER(hHandle5);

  CryptoWrappers::CCNGKey2 key32;
  secStatus = storprov2.CreatePersistedKey(NCRYPT_RSA_ALGORITHM, nullptr, 0, 0, key32); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(secStatus));
  secStatus = key32.Finalize(0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(secStatus));
  cbResult = 0;
#pragma warning(suppress: 26465 26472 26490 26492)
  secStatus = key32.Encrypt(const_cast<PBYTE>(reinterpret_cast<const BYTE*>(pszPlainText)), static_cast<DWORD>(strlen(pszPlainText)), nullptr, nullptr, 0, &cbResult, NCRYPT_NO_PADDING_FLAG); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(secStatus));
  binary.resize(cbResult);
#pragma warning(suppress: 26472)
  secStatus = key32.Decrypt(binary.data(), static_cast<DWORD>(binary.size()), nullptr, nullptr, 0, &cbResult, 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(secStatus));
  std::vector<BYTE> decrypted{cbResult, std::allocator<BYTE>{}};
#pragma warning(suppress: 26472)
  status = key32.Decrypt(binary.data(), static_cast<DWORD>(binary.size()), nullptr, decrypted.data(), static_cast<ULONG>(decrypted.size()), &cbResult, 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(secStatus));

  CryptoWrappers::CCNGKey2 key33;
  secStatus = storprov2.CreatePersistedKey(NCRYPT_ECDSA_P256_ALGORITHM, nullptr, 0, 0, key33); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(secStatus));
  secStatus = key33.Finalize(0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(secStatus));
  dwDataLen = 0;
#pragma warning(suppress: 26472)
  secStatus = key33.SignHash(nullptr, Hash.data(), static_cast<DWORD>(Hash.size()), nullptr, 0, &dwDataLen, 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(secStatus));
  binary.resize(dwDataLen);
  DWORD dwOutDataLen{0};
#pragma warning(suppress: 26472)
  secStatus = key33.SignHash(nullptr, Hash.data(), static_cast<DWORD>(Hash.size()), binary.data(), dwDataLen, &dwOutDataLen, 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(secStatus));
#pragma warning(suppress: 26472)
  secStatus = key33.VerifySignature(nullptr, Hash.data(), static_cast<DWORD>(Hash.size()), binary.data(), dwDataLen, 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(secStatus));

  bSuccess = key32.SignAndEncodeCertificate(X509_ASN_ENCODING, X509_CERT_REQUEST_TO_BE_SIGNED, &cri, &SigAlg, nullptr, &cbEncodedCertReqSize); //NOLINT(clang-analyzer-deadcode.DeadStores)
  bSuccess = key32.SignCertificate(X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, nullptr, 0, &SigAlg, nullptr, &dwDataLen); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess);

  secStatus = key25.Delete(0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(secStatus));

#if (NTDDI_VERSION >= NTDDI_WIN8)
  CryptoWrappers::CCNGKey2 key34;
  secStatus = storprov2.CreatePersistedKey(NCRYPT_PBKDF2_ALGORITHM, nullptr, 0, 0, key34);
  ATLASSUME(SUCCEEDED(secStatus));
  secStatus = key34.Finalize(0);
  ATLASSUME(SUCCEEDED(secStatus));
  cbResult = 0;
  secStatus = key34.KeyDerivation(nullptr, keyData, sizeof(keyData), &cbResult, 0);
#endif //#if (NTDDI_VERSION >= NTDDI_WIN8)

  return 0;
}
